# Enum VpnProtocol

java.lang.Object
java.lang.Enum<VpnProtocol>
com.codename1.vpn.VpnProtocol

All Implemented Interfaces:
  `Comparable<VpnProtocol>`

public enum VpnProtocol extends Enum<VpnProtocol>

The tunnelling protocol a configuration uses.

The list is short because it is limited to what both platforms can be asked to run without the app shipping its own tunnel. Anything else needs a packet tunnel, which is a much larger commitment; see the `com.codename1.vpn` package documentation.

The ordinals cross the SPI boundary, so existing constants must not be reordered.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `IKEV2`
  IKEv2, the protocol both platforms implement themselves.
  `IPSEC`
  IPsec with a pre-shared key.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VpnProtocol`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static VpnProtocol[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, equals, getDeclaringClass, getEnumValues, hashCode, name, ordinal, setEnumValues, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### IKEV2

    public static final VpnProtocol IKEV2
    IKEv2, the protocol both platforms implement themselves. This is the one to use unless there is a reason not to.

  - ### IPSEC

    public static final VpnProtocol IPSEC
    IPsec with a pre-shared key. Available on iOS; Android's managed profile API does not offer it, and reports `VpnError.NOT_SUPPORTED`.

- ## Method Details

  - ### values

    public static VpnProtocol[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static VpnProtocol valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null